<script>
import { GlAlert, GlSafeHtmlDirective as SafeHtml } from "@gitlab/ui";
import { getCookie, setCookie } from "../utils/cookies";

export default {
  directives: {
    SafeHtml,
  },
  components: {
    GlAlert,
  },
  props: {
    bannerType: {
      type: String,
      required: true,
      validator: (value) => ["survey", "archive"].includes(value),
    },
    text: {
      type: String,
      required: true,
    },
    variant: {
      type: String,
      required: true,
    },
    dismissible: {
      type: Boolean,
      required: false,
      default: true,
    },
  },
  data() {
    return {
      showBanner: true,
    };
  },
  computed: {
    renderBanner() {
      if (this.bannerType === "survey") {
        return this.showBanner;
      }

      return this.showBanner || !this.dismissible;
    },
    bannerAlertStyle() {
      const styles = {
        survey: "gl-mt-6",
        archive: "gl-text-lg gl-text-center",
      };
      return styles[this.bannerType];
    },
    bannerTextStyle() {
      const styles = {
        survey: "gl-leading-24",
        archive: "gl-leading-none",
      };
      return styles[this.bannerType];
    },
  },
  created() {
    this.showBanner = getCookie("HideDocsBanner") !== "1";
  },
  methods: {
    dismissAlert() {
      this.showBanner = false;
      setCookie("HideDocsBanner", 1, 30);
    },
  },
};
</script>

<template>
  <gl-alert
    v-if="renderBanner"
    :variant="variant"
    :dismissible="dismissible"
    :show-icon="false"
    :class="['gl-docs', 'gl-z-3', bannerAlertStyle]"
    @dismiss="dismissAlert()"
  >
    <div
      v-safe-html="text"
      :class="['gl-layout-w-limited', 'gl-m-auto', bannerTextStyle]"
    ></div>
  </gl-alert>
</template>
